Index: typo3/sysext/rtehtmlarea/htmlarea/plugins/CopyPaste/copy-paste.js
===================================================================
--- typo3/sysext/rtehtmlarea/htmlarea/plugins/CopyPaste/copy-paste.js	(révision 6908)
+++ typo3/sysext/rtehtmlarea/htmlarea/plugins/CopyPaste/copy-paste.js	(copie de travail)
@@ -1,7 +1,7 @@
 /***************************************************************
 *  Copyright notice
 *
-*  (c) 2008-2009 Stanislas Rolland <typo3(arobas)sjbr.ca>
+*  (c) 2008-2010 Stanislas Rolland <typo3(arobas)sjbr.ca>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
@@ -49,7 +49,7 @@
 		 * Registering plugin "About" information
 		 */
 		var pluginInformation = {
-			version		: "1.0",
+			version		: "2.0",
 			developer	: "Stanislas Rolland",
 			developerUrl	: "http://www.sjbr.ca/",
 			copyrightOwner	: "Stanislas Rolland",
@@ -70,14 +70,14 @@
 					tooltip		: this.localize(buttonId.toLowerCase()),
 					action		: "onButtonPress",
 					context		: button[0],
+					selection	: button[3],
 					hotKey		: (this.buttonsConfiguration[button[2]] ? this.buttonsConfiguration[button[2]].hotKey : (button[1] ? button[1] : null))
 				};
 				this.registerButton(buttonConfiguration);
 				if (!this.isButtonInToolbar(buttonId)) {
 					var hotKeyConfiguration = {
 						id	: buttonConfiguration.hotKey,
-						cmd	: buttonConfiguration.id,
-						action	: buttonConfiguration.action
+						cmd	: buttonConfiguration.id
 					};
 					this.registerHotKey(hotKeyConfiguration);
 				}
@@ -90,9 +90,9 @@
 	 * The list of buttons added by this plugin
 	 */
 	buttonList : {
-		Copy	: [null, "c", "copy"],
-		Cut	: [null, "x", "cut"],
-		Paste	: [null, "v", "paste"]
+		Copy	: [null, "c", "copy", true],
+		Cut	: [null, "x", "cut", true],
+		Paste	: [null, "v", "paste", false]
 	},
 	
 	/*
@@ -119,8 +119,7 @@
 						this.applyBrowserCommand(buttonId);
 					} else if (buttonId == "Cut") {
 							// If we are handling the cut hotkey
-						var removeEmpyLinkLaterFunctRef = this.makeFunctionReference("removeEmptyLinkLater");
-						window.setTimeout(removeEmpyLinkLaterFunctRef, 50);
+						this.removeEmptyLinkLater.defer(50, this);
 					}
 					break;
 				case "Paste":
@@ -129,11 +128,14 @@
 						this.applyBrowserCommand(buttonId);
 					}
 						// In FF3, the paste operation will indeed trigger the onPaste event not in FF2; nor in Opera
-					if (HTMLArea.is_opera || (HTMLArea.is_gecko && navigator.productSub < 20080514) || HTMLArea.is_safari) {
-						var cleanLaterFunctRef = this.getPluginInstance("DefaultClean") ? this.getPluginInstance("DefaultClean").cleanLaterFunctRef : (this.getPluginInstance("TYPO3HtmlParser") ? this.getPluginInstance("TYPO3HtmlParser").cleanLaterFunctRef : null);
-						if (cleanLaterFunctRef) {
-							window.setTimeout(cleanLaterFunctRef, 50);
+					if (Ext.isOpera || Ext.isGecko2 || Ext.isWebKit) {
+						var cleaner = this.getPluginInstance('DefaultClean');
+						if (!cleaner) {
+							cleaner = this.getPluginInstance('TYPO3HtmlParser');
 						}
+						if (cleaner) {
+							cleaner.clean.defer(50, cleaner);
+						}
 					}
 					break;
 				default:
@@ -150,7 +152,7 @@
 		try {
 			this.editor._doc.execCommand(buttonId, false, null);
 		} catch (e) {
-			if (HTMLArea.is_gecko && !HTMLArea.is_safari && !HTMLArea.is_opera) {
+			if (Ext.isGecko) {
 				this.mozillaClipboardAccessException();
 			}
 		}
@@ -172,11 +174,11 @@
 		if (/^(a)$/i.test(parent.nodeName)) {
 			parent.normalize();
 			if (!parent.innerHTML || (parent.childNodes.length == 1 && /^(br)$/i.test(parent.firstChild.nodeName))) {
-				if (HTMLArea.is_gecko) {
+				if (!Ext.isIE) {
 					var container = parent.parentNode;
 					this.editor.removeMarkup(parent);
 						// Opera does not render empty list items
-					if (HTMLArea.is_opera && /^(li)$/i.test(container.nodeName) && !container.firstChild) {
+					if (Ext.isOpera && /^(li)$/i.test(container.nodeName) && !container.firstChild) {
 						container.innerHTML = "<br />";
 						this.editor.selectNodeContents(container, true);
 					}
@@ -185,7 +187,7 @@
 				}
 			}
 		}
-		if (HTMLArea.is_safari) {
+		if (Ext.isWebKit) {
 				// Remove Apple's span and font tags
 			this.editor.cleanAppleStyleSpans(this.editor._doc.body);
 				// Reset Safari selection in order to prevent insertion of span and/or font tags on next text input
@@ -215,7 +217,7 @@
 			case "Cut" :
 				HTMLArea.copiedCells = null;
 				var endBlocks = this.editor.getEndBlocks(selection);
-				if ((/^(tr)$/i.test(parent.nodeName) && HTMLArea.is_gecko) || (/^(td|th)$/i.test(endBlocks.start.nodeName) && /^(td|th)$/i.test(endBlocks.end.nodeName) && (HTMLArea.is_ie || HTMLArea.is_safari || HTMLArea.is_opera) && endBlocks.start != endBlocks.end)) {
+				if ((/^(tr)$/i.test(parent.nodeName) && !Ext.isIE) || (/^(td|th)$/i.test(endBlocks.start.nodeName) && /^(td|th)$/i.test(endBlocks.end.nodeName) && !Ext.isGecko && endBlocks.start != endBlocks.end)) {
 					HTMLArea.copiedCells = this.collectCells(buttonId, selection, endBlocks);
 					if (buttonId === "Cut") return true;
 				}
@@ -231,7 +233,7 @@
 	
 	pasteCells : function (selection, endBlocks) {
 		var cell = null;
-		if (HTMLArea.is_gecko && !HTMLArea.is_safari && !HTMLArea.is_opera) {
+		if (Ext.isGecko) {
 			range = selection.getRangeAt(0);
 			cell = range.startContainer.childNodes[range.startOffset];
 			while (cell && !HTMLArea.isBlockElement(cell)) {
@@ -289,7 +291,7 @@
 		}
 		var row = null;
 		var cutRows = [];
-		if (HTMLArea.is_gecko && !HTMLArea.is_safari && !HTMLArea.is_opera) {  // Firefox
+		if (Ext.isGecko) {
 			if (selection.rangeCount == 1) { // Collect the cells in the selected row
 				cells = [];
 				for (var i = 0, n = endBlocks.start.cells.length; i < n; ++i) {
@@ -389,19 +391,16 @@
 	/*
 	 * This function gets called when the toolbar is updated
 	 */
-	onUpdateToolbar : function () {
-		if (this.getEditorMode() === "wysiwyg" || this.editor.isEditable()) {
-			var buttonId = "Paste";
-			if (typeof(this.editor._toolbarObjects[buttonId]) !== "undefined") {
-				try {
-					this.editor._toolbarObjects[buttonId].state("enabled", this.editor._doc.queryCommandEnabled(buttonId));
-				} catch(e) {
-					this.editor._toolbarObjects[buttonId].state("enabled", false);
-				}
+	onUpdateToolbar: function (button, mode, selectionEmpty, ancestors) {
+		if (mode === 'wysiwyg' && this.editor.isEditable() && button.itemId === 'Paste') {
+			try {
+				button.setDisabled(!this.editor._doc.queryCommandEnabled(button.itemId));
+			} catch(e) {
+				button.setDisabled(true);
 			}
 		}
 	},
-
+	
 	/*
 	 * Mozilla clipboard access exception handler
 	 */
Index: typo3/sysext/rtehtmlarea/htmlarea/plugins/DefaultClean/default-clean.js
===================================================================
--- typo3/sysext/rtehtmlarea/htmlarea/plugins/DefaultClean/default-clean.js	(révision 6908)
+++ typo3/sysext/rtehtmlarea/htmlarea/plugins/DefaultClean/default-clean.js	(copie de travail)
@@ -1,7 +1,7 @@
 /***************************************************************
 *  Copyright notice
 *
-*  (c) 2008-2009 Stanislas Rolland <typo3(arobas)sjbr.ca>
+*  (c) 2008-2010 Stanislas Rolland <typo3(arobas)sjbr.ca>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
@@ -63,7 +63,8 @@
 			id		: buttonId,
 			tooltip		: this.localize(buttonId + "-Tooltip"),
 			action		: "onButtonPress",
-			hide		: true
+			hide		: true,
+			hideInContextMenu: true
 		};
 		this.registerButton(buttonConfiguration);
 	},
@@ -84,14 +85,16 @@
 		this.clean();
 		return false;
 	},
-	
-	onGenerate : function () {
-		var doc = this.editor._doc;
-			// Function reference used on paste with older versions of Mozilla/Firefox in which onPaste is not fired
-		this.cleanLaterFunctRef = this.makeFunctionReference("clean");
-		HTMLArea._addEvents((HTMLArea.is_ie ? doc.body : doc), ["paste","dragdrop","drop"], DefaultClean.wordCleanHandler, true);
+	/*
+	 * This function gets called when the editor is generated
+	 */
+	onGenerate: function () {
+		var documentElement = Ext.get(Ext.isIE ? this.editor.document.body : this.editor.document.documentElement);
+		this.editor.iframe.mon(documentElement, 'paste', this.wordCleanHandler, this);
+		this.editor.iframe.mon(documentElement, 'dragdrop', this.wordCleanHandler, this);
+		this.editor.iframe.mon(documentElement, 'drop', this.wordCleanHandler, this);
 	},
-	
+
 	clean : function () {
 		function clearClass(node) {
 			var newc = node.className.replace(/(^|\s)mso.*?(\s|$)/ig,' ');
@@ -167,34 +170,16 @@
 		if (HTMLArea.is_safari) {
 			this.editor.cleanAppleStyleSpans(this.editor._doc.body);
 		}
+	},
+	/*
+	 * Handler for paste, dragdrop and drop events
+	 */
+	wordCleanHandler: function (event) {
+			// If we dropped an image dragged from the TYPO3 Image plugin, let's close the dialog window
+		if (typeof(HTMLArea.Dialog) != "undefined" && HTMLArea.Dialog.TYPO3Image) {
+			HTMLArea.Dialog.TYPO3Image.close();
+		} else {
+			this.clean.defer(250, this);
+		}
 	}
 });
-
-/*
- * Closure avoidance for IE
- */
-DefaultClean.cleanLater = function (editorNumber) {
-	var editor = RTEarea[editorNumber].editor;
-	editor.getPluginInstance("DefaultClean").clean();
-};
-
-/*
- * Handler for paste, dragdrop and drop events
- */
-DefaultClean.wordCleanHandler = function (ev) {
-	if (!ev) var ev = window.event;
-	var target = ev.target ? ev.target : ev.srcElement;
-	var owner = target.ownerDocument ? target.ownerDocument : target;
-	if (HTMLArea.is_ie) { // IE5.5 does not report any ownerDocument
-		while (owner.parentElement) { owner = owner.parentElement; }
-	}
-	var editor = RTEarea[owner._editorNo].editor;
-
-		// If we dropped an image dragged from the TYPO3 Image plugin, let's close the dialog window
-	if (typeof(HTMLArea.Dialog) != "undefined" && HTMLArea.Dialog.TYPO3Image) {
-		HTMLArea.Dialog.TYPO3Image.close();
-	} else {
-		window.setTimeout("DefaultClean.cleanLater(\'" + editor._editorNumber + "\');", 250);
-	}
-};
-
Index: typo3/sysext/rtehtmlarea/htmlarea/plugins/DefaultInline/default-inline.js
===================================================================
--- typo3/sysext/rtehtmlarea/htmlarea/plugins/DefaultInline/default-inline.js	(révision 6908)
+++ typo3/sysext/rtehtmlarea/htmlarea/plugins/DefaultInline/default-inline.js	(copie de travail)
@@ -1,7 +1,7 @@
 /***************************************************************
 *  Copyright notice
 *
-*  (c) 2007-2009 Stanislas Rolland <stanislas.rolland(arobas)fructifor.ca>
+*  (c) 2007-2010 Stanislas Rolland <typo3(arobas)sjbr.ca>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
@@ -44,7 +44,7 @@
 		 * Registering plugin "About" information
 		 */
 		var pluginInformation = {
-			version		: "1.0",
+			version		: "1.1",
 			developer	: "Stanislas Rolland",
 			developerUrl	: "http://www.fructifor.ca/",
 			copyrightOwner	: "Stanislas Rolland",
@@ -57,11 +57,8 @@
 		/*
 		 * Registering the buttons
 		 */
-		var buttonList = DefaultInline.buttonList, buttonId;
-		var n = buttonList.length;
-		for (var i = 0; i < n; ++i) {
-			var button = buttonList[i];
-			buttonId = button[0];
+		Ext.each(this.buttonList, function (button) {
+			var buttonId = button[0];
 			var buttonConfiguration = {
 				id		: buttonId,
 				tooltip		: this.localize(buttonId + "-Tooltip"),
@@ -71,11 +68,19 @@
 				hotKey		: (this.editorConfiguration.buttons[buttonId.toLowerCase()]?this.editorConfiguration.buttons[buttonId.toLowerCase()].hotKey:null)
 			};
 			this.registerButton(buttonConfiguration);
-		}
-		
+			return true;
+		}, this);
 		return true;
-	 },
-	 
+	},
+	/* The list of buttons added by this plugin */
+	buttonList: [
+		["Bold", null],
+		["Italic", null],
+		["StrikeThrough", null],
+		["Subscript", null],
+		["Superscript", null],
+		["Underline", null]
+	],
 	/*
 	 * This function gets called when some inline element button was pressed.
 	 */
@@ -96,34 +101,16 @@
 	/*
 	 * This function gets called when the toolbar is updated
 	 */
-	onUpdateToolbar : function () {
-		var editor = this.editor;
-		var buttonList = DefaultInline.buttonList;
-		var buttonId, n = buttonList.length, commandState;
-		if (editor.getMode() === "wysiwyg" && editor.isEditable()) {
-			for (var i = 0; i < n; ++i) {
-				buttonId = buttonList[i][0];
-				if (this.isButtonInToolbar(buttonId)) {
-					commandState = false;
-					try {
-						commandState = editor._doc.queryCommandState(buttonId);
-					} catch(e) {
-						commandState = false;
-					}
-					editor._toolbarObjects[buttonId].state("active", commandState);
-				}
+	onUpdateToolbar: function (button, mode, selectionEmpty, ancestors) {
+		if (mode === 'wysiwyg' && this.editor.isEditable()) {
+			var commandState = false;
+			try {
+				commandState = this.editor._doc.queryCommandState(button.itemId);
+			} catch(e) {
+				commandState = false;
 			}
+			button.setInactive(!commandState);
 		}
 	}
 });
 
-/* The list of buttons added by this plugin */
-DefaultInline.buttonList = [
-	["Bold", null],
-	["Italic", null],
-	["StrikeThrough", null],
-	["Subscript", null],
-	["Superscript", null],
-	["Underline", null]
-];
-
Index: typo3/sysext/rtehtmlarea/htmlarea/plugins/DefinitionList/definition-list.js
===================================================================
--- typo3/sysext/rtehtmlarea/htmlarea/plugins/DefinitionList/definition-list.js	(révision 6908)
+++ typo3/sysext/rtehtmlarea/htmlarea/plugins/DefinitionList/definition-list.js	(copie de travail)
@@ -1,7 +1,7 @@
 /***************************************************************
 *  Copyright notice
 *
-*  (c) 2008-2009 Stanislas Rolland <typo3(arobas)sjbr.ca>
+*  (c) 2008-2010 Stanislas Rolland <typo3(arobas)sjbr.ca>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
@@ -71,34 +71,36 @@
 		/*
 		 * Registering the buttons
 		 */
-		for (var buttonId in this.buttonList) {
-			if (this.buttonList.hasOwnProperty(buttonId)) {
-				var button = this.buttonList[buttonId];
-				var buttonConfiguration = {
-					id		: buttonId,
-					tooltip		: this.localize(buttonId + "-Tooltip"),
-					action		: "onButtonPress",
-					context		: button[0],
-					hotKey		: (this.buttonsConfiguration[button[2]] ? this.buttonsConfiguration[button[2]].hotKey : (button[1] ? button[1] : null))
-				};
-				this.registerButton(buttonConfiguration);
-			}
-		}
-		
+		Ext.each(this.buttonList, function (button) {
+			var buttonId = button[0];
+			var buttonConfiguration = {
+				id		: buttonId,
+				tooltip		: this.localize(buttonId + "-Tooltip"),
+				action		: "onButtonPress",
+				context		: button[1],
+				hotKey		: (this.buttonsConfiguration[button[3]] ? this.buttonsConfiguration[button[3]].hotKey : (button[2] ? button[2] : null)),
+				noAutoUpdate	: button[4]
+			};
+			this.registerButton(buttonConfiguration);
+		}, this);
 		return true;
 	 },
 	 
 	/*
 	 * The list of buttons added by this plugin
 	 */
-	buttonList : {
-		Indent			: [null, "TAB", "indent"],
-		Outdent			: [null, "SHIFT-TAB", "outdent"],
-		DefinitionList		: [null, null, "definitionlist"],
-		DefinitionItem		: ["dd,dt", null, "definitionitem"]
-	},
-	
+	buttonList : [
+		['Indent', null, 'TAB', 'indent', false],
+		['Outdent', null, 'SHIFT-TAB', 'outdent', false],
+		['DefinitionList', null, null, 'definitionlist', true],
+		['DefinitionItem', 'dd,dt', null, 'definitionitem', false]
+	 ],
 	/*
+	 * This function gets called when the plugin is generated
+	 * Avoid re-execution of the base function
+	 */
+	onGenerate: Ext.emptyFn,
+	/*
 	 * This function gets called when a button was pressed.
 	 *
 	 * @param	object		editor: the editor instance
@@ -115,7 +117,7 @@
 		this.editor.focusEditor();
 		var selection = editor._getSelection();
 		var range = editor._createRange(selection);
-		var statusBarSelection = editor.getPluginInstance("StatusBar") ? editor.getPluginInstance("StatusBar").getSelection() : null;
+		var statusBarSelection = this.editor.statusBar ? this.editor.statusBar.getSelection() : null;
 		var parentElement = statusBarSelection ? statusBarSelection : this.editor.getParentElement(selection, range);
 		if (target) {
 			parentElement = target;
@@ -311,36 +313,27 @@
 	/*
 	 * This function gets called when the toolbar is updated
 	 */
-	onUpdateToolbar : function () {
-		if (this.getEditorMode() === "textmode" || !this.editor.isEditable()) {
-			return false;
-		}
-		var statusBarSelection = this.editor.getPluginInstance("StatusBar") ? this.editor.getPluginInstance("StatusBar").getSelection() : null;
-		var parentElement = statusBarSelection ? statusBarSelection : this.editor.getParentElement();
-		if (parentElement.nodeName.toLowerCase() === "body") return false;
-		while (parentElement && (!HTMLArea.isBlockElement(parentElement) || /^(li)$/i.test(parentElement.nodeName))) {
-			parentElement = parentElement.parentNode;
-		}
-		var blockAncestors = this.getBlockAncestors(parentElement);
-		var selection = this.editor._getSelection();
-		var endBlocks = this.editor.getEndBlocks(selection);
-		for (var buttonId in this.buttonList) {
-			commandState = false;
-			if (this.buttonList.hasOwnProperty(buttonId) && this.isButtonInToolbar(buttonId)) {
-				switch (buttonId) {
-					case "Outdent" :
+	onUpdateToolbar: function (button, mode, selectionEmpty, ancestors) {
+		var editor = this.editor;
+		if (mode === 'wysiwyg' && this.editor.isEditable()) {
+			var statusBarSelection = this.editor.statusBar ? this.editor.statusBar.getSelection() : null;
+			var parentElement = statusBarSelection ? statusBarSelection : editor.getParentElement();
+			if (!/^(body)$/i.test(parentElement.nodeName)) {
+				var endBlocks = editor.getEndBlocks(editor._getSelection());
+				switch (button.itemId) {
+					case 'Outdent':
 						if (/^(dt)$/i.test(endBlocks.start.nodeName)
 								&& /^(dl)$/i.test(endBlocks.start.parentNode.nodeName)
 								&& /^(dd)$/i.test(endBlocks.start.parentNode.parentNode.nodeName)
 								&& !endBlocks.end.nextSibling) {
-							this.editor._toolbarObjects[buttonId].state("enabled", true);
+							button.setDisabled(false);
 						} else {
-							this.base();
+							this.base(button, mode, selectionEmpty, ancestors);
 						}
 						break;
-					case "DefinitionList" :
-						this.editor._toolbarObjects[buttonId].state("enabled", (this.editor._selectionEmpty() && /^(p|div|address|pre|blockquote|h[1-6]|li|td|dd)$/i.test(endBlocks.start.nodeName))
-													|| (endBlocks.start != endBlocks.end && /^(p|h[1-6])$/i.test(endBlocks.start.nodeName)));
+					case 'DefinitionList':
+						button.setDisabled(!(selectionEmpty && /^(p|div|address|pre|blockquote|h[1-6]|li|td|dd)$/i.test(endBlocks.start.nodeName))
+													&& !(endBlocks.start != endBlocks.end && /^(p|h[1-6])$/i.test(endBlocks.start.nodeName)));
 						break;
 				}
 			}
Index: typo3/sysext/rtehtmlarea/htmlarea/plugins/EditorMode/editor-mode.js
===================================================================
--- typo3/sysext/rtehtmlarea/htmlarea/plugins/EditorMode/editor-mode.js	(révision 6908)
+++ typo3/sysext/rtehtmlarea/htmlarea/plugins/EditorMode/editor-mode.js	(copie de travail)
@@ -1,7 +1,7 @@
 /***************************************************************
 *  Copyright notice
 *
-*  (c) 2009 Stanislas Rolland <typo3(arobas)sjbr.ca>
+*  (c) 2009-2010 Stanislas Rolland <typo3(arobas)sjbr.ca>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
@@ -30,21 +30,18 @@
  * TYPO3 SVN ID: $Id$
  */
 EditorMode = HTMLArea.Plugin.extend({
-
 	constructor : function(editor, pluginName) {
 		this.base(editor, pluginName);
 	},
-
 	/*
 	 * This function gets called by the class constructor
 	 */
 	configurePlugin : function (editor) {
-
 		/*
 		 * Registering plugin "About" information
 		 */
 		var pluginInformation = {
-			version		: "0.1",
+			version		: "2.0",
 			developer	: "Stanislas Rolland",
 			developerUrl	: "http://www.sjbr.ca/",
 			copyrightOwner	: "Stanislas Rolland",
@@ -53,7 +50,6 @@
 			license		: "GPL"
 		};
 		this.registerPluginInformation(pluginInformation);
-
 		/*
 		 * Registering the buttons
 		 */
@@ -71,64 +67,13 @@
 			this.registerButton(buttonConfiguration);
 		}
 		return true;
-	 },
-
-	/* The list of buttons added by this plugin */
-	buttonList : [
-		["TextMode", null]
-	],
-
-	/*
-	 * This function gets called during the editor generation and initializes the editor mode
-	 *
-	 * @return	void
-	 */
-	init : function () {
-		var doc = this.editor._doc;
-			// Catch error if html content is invalid
-		var documentIsWellFormed = true;
-		try {
-			doc.body.innerHTML = this.editor._textArea.value;
-		} catch(e) {
-			this.appendToLog("init", "The HTML document is not well-formed.");
-			alert(this.localize("HTML-document-not-well-formed"));
-			documentIsWellFormed = false;
-		}
-			// Set contents editable
-		if (documentIsWellFormed) {
-			if (HTMLArea.is_gecko && !HTMLArea.is_safari && !HTMLArea.is_opera && !this.editor._initEditMode()) {
-				return false;
-			}
-			if (HTMLArea.is_ie || HTMLArea.is_safari) {
-				doc.body.contentEditable = true;
-			}
-			if (HTMLArea.is_opera || HTMLArea.is_safari) {
-				doc.designMode = "on";
-				this.setGeckoOptions();
-			}
-			this.editorMode = "wysiwyg";
-			if (doc.body.contentEditable || doc.designMode == "on") {
-				this.appendToLog("init", "Design mode successfully set.");
-			}
-		} else {
-			this.editorMode = "textmode";
-			this.setEditorMode("docnotwellformedmode");
-			this.appendToLog("init", "Design mode could not be set.");
-		}
-		return true;
 	},
-
-	/*
-	 * This function gets called when the editor is generated
-	 *
-	 * @return 	void
+	/**
+	 * The list of buttons added by this plugin
 	 */
-	onGenerate : function () {
-			// Set some references
-		this.textArea = this.editor._textArea;
-		this.editorBody = this.editor._doc.body;
-	},
-
+	buttonList: [
+		['TextMode', null]
+	],
 	/*
 	 * This function gets called when a button was pressed.
 	 *
@@ -137,173 +82,19 @@
 	 *
 	 * @return	boolean		false if action is completed
 	 */
-	onButtonPress : function (editor, id, target) {
+	onButtonPress: function (editor, id, target) {
 			// Could be a button or its hotkey
 		var buttonId = this.translateHotKey(id);
 		buttonId = buttonId ? buttonId : id;
-		this.setEditorMode((this.getEditorMode() == buttonId.toLowerCase()) ? "wysiwyg" : buttonId.toLowerCase());
+		this.editor.setMode((this.editor.getMode() == buttonId.toLowerCase()) ? 'wysiwyg' : buttonId.toLowerCase());
 		return false;
 	},
-
 	/*
-	 * Switch editor mode
-	 *
-	 * @param	string	"textmode" or "wysiwyg"; if no parameter was passed, toggle between modes.
-	 * @return	void
-	 */
-	setEditorMode : function (mode) {
-		var editor = this.editor;
-		switch (mode) {
-			case "textmode":
-			case "docnotwellformedmode":
-				this.textArea.value = this.getHTML();
-				editor._iframe.style.display = "none";
-				var dimensions = editor.getDimensions();
-				editor.htmlArea.setStyle('height', (dimensions.toolbar.height + dimensions.statusbar.height) + 'px');
-				editor.htmlArea.removeClass('resizable');
-				this.textArea.style.display = "block";
-				this.editorMode = "textmode";
-				break;
-			case "wysiwyg":
-				if (HTMLArea.is_gecko && !HTMLArea.is_safari && !HTMLArea.is_opera) {
-					editor._doc.designMode = "off";
-				}
-				try {
-					this.editorBody.innerHTML = this.getHTML();
-				} catch(e) {
-					alert(HTMLArea.I18N.msg["HTML-document-not-well-formed"]);
-					break;
-				}
-				this.textArea.style.display = "none";
-				editor._iframe.style.display = "block";
-				var dimensions = editor.getDimensions();
-				editor.htmlArea.setStyle('height', (parseInt(editor.iframe.getStyle('height')) + dimensions.toolbar.height + dimensions.statusbar.height) + 'px');
-				editor.htmlArea.addClass('resizable');
-				if (HTMLArea.is_gecko && !HTMLArea.is_safari && !HTMLArea.is_opera) {
-					editor._doc.designMode = "on";
-				}
-				this.editorMode = "wysiwyg";
-				this.setGeckoOptions();
-				break;
-			case "htmlmode":
-				this.editorMode = "htmlmode";
-				break;
-			default:
-				return false;
-		}
-		if (mode !== "docnotwellformedmode") {
-			editor.focusEditor();
-		}
-		for (var pluginId in editor.plugins) {
-			if (editor.plugins.hasOwnProperty(pluginId)) {
-				var pluginInstance = this.getPluginInstance(pluginId);
-				if (typeof(pluginInstance.onMode) === "function") {
-					pluginInstance.onMode(mode);
-				}
-			}
-		}
-	},
-
-	/*
-	 * Set gecko editing mode options (if we can... raises exception in Firefox 3)
-	 *
-	 * @return	void
-	 */
-	setGeckoOptions : function () {
-		if (HTMLArea.is_gecko) {
-			var doc = this.editor._doc;
-			var config = this.editor.config;
-			try {
-				if (doc.queryCommandEnabled("insertbronreturn")) {
-					doc.execCommand("insertbronreturn", false, config.disableEnterParagraphs);
-				}
-				if (doc.queryCommandEnabled("styleWithCSS")) {
-					doc.execCommand("styleWithCSS", false, config.useCSS);
-				} else if (!HTMLArea.is_opera && !HTMLArea.is_safari && doc.queryCommandEnabled("useCSS")) {
-					doc.execCommand("useCSS", false, !config.useCSS);
-				}
-				if (!HTMLArea.is_opera && !HTMLArea.is_safari) {
-					if (doc.queryCommandEnabled("enableObjectResizing")) {
-						doc.execCommand("enableObjectResizing", false, !config.disableObjectResizing);
-					}
-					if (doc.queryCommandEnabled("enableInlineTableEditing")) {
-						doc.execCommand("enableInlineTableEditing", false, (config.buttons.table && config.buttons.table.enableHandles) ? true : false);
-					}
-				}
-			} catch(e) {}
-		}
-	},
-
-	/*
-	 * Get editor mode
-	 *
-	 * @return	string	the current editor mode
-	 */
-	getEditorMode : function() {
-		return this.editorMode;
-	},
-
-	/*
 	 * This function gets called when the toolbar is updated
 	 *
 	 * @return	void
 	 */
-	onUpdateToolbar : function () {
-		var buttonList = this.buttonList, buttonId;
-		for (var i = 0, n = buttonList.length; i < n; ++i) {
-			buttonId = buttonList[i][0];
-			if (this.isButtonInToolbar(buttonId)) {
-				this.editor._toolbarObjects[buttonId].state("active", (this.getEditorMode() == buttonId.toLowerCase()));
-			}
-		}
-	},
-
-	/*
-	 * Retrieve the HTML
-	 * In the case of the wysiwyg mode, the html content is parsed
-	 *
-	 * @return	string	the textual html content from the current editing mode
-	 */
-	getHTML : function () {
-		switch (this.editorMode) {
-			case "wysiwyg":
-				return HTMLArea.getHTML(this.editorBody, false, this.editor);
-			case "textmode":
-				return this.textArea.value;
-		}
-		return "";
-	},
-
-	/*
-	 * Retrieve raw HTML
-	 *
-	 * @return	string	the textual html content from the current editing mode
-	 */
-	getInnerHTML : function () {
-		switch (this.editorMode) {
-			case "wysiwyg":
-				return this.editorBody.innerHTML;
-			case "textmode":
-				return this.textArea.value;
-		}
-		return "";
-	},
-
-	/*
-	 * Replace the HTML inside
-	 *
-	 * @param	string	html: the textual html
-	 * @return	boolean	false
-	 */
-	setHTML : function (html) {
-		switch (this.editorMode) {
-			case "wysiwyg":
-				this.editorBody.innerHTML = html;
-				break;
-			case "textmode":
-				this.textArea.value = html;
-				break;
-		}
-		return false;
+	onUpdateToolbar: function (button, mode, selectionEmpty, ancestors) {
+		button.setInactive(mode !== button.itemId.toLowerCase());
 	}
 });
Index: typo3/sysext/rtehtmlarea/htmlarea/plugins/FindReplace/find-replace.js
===================================================================
--- typo3/sysext/rtehtmlarea/htmlarea/plugins/FindReplace/find-replace.js	(révision 6908)
+++ typo3/sysext/rtehtmlarea/htmlarea/plugins/FindReplace/find-replace.js	(copie de travail)
@@ -2,7 +2,7 @@
 *  Copyright notice
 *
 *  (c) 2004 Cau guanabara <caugb@ibest.com.br>
-*  (c) 2005-2009 Stanislas Rolland <typo3(arobas)sjbr.ca>
+*  (c) 2005-2010 Stanislas Rolland <typo3(arobas)sjbr.ca>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
@@ -96,10 +96,9 @@
 		if (/\w/.test(sel)) {
 			param = { fr_pattern: sel };
 		}
-		if (HTMLArea.is_opera) {
-			this.cleanUpFunctionReference = this.makeFunctionReference("cleanUp");
+		if (Ext.isOpera) {
 			this.cleanUpRegularExpression = /(<span\s+[^>]*id=.?frmark[^>]*>)([^<>]*)(<\/span>)/gi;
-			this.editor._iframe.contentWindow.setTimeout(this.cleanUpFunctionReference, 200);
+			this.cleanUp.defer(200, this);
 		}
 		this.dialog = this.openDialog("FindReplace", this.makeUrlFromPopupName("find_replace"), null, param, {width:this.popupWidth, height:this.popupHeight});
 		return false;
@@ -112,10 +111,10 @@
 	 */
 	cleanUp : function () {
 		if (this.dialog && (!this.dialog.dialogWindow || (this.dialog.dialogWindow && this.dialog.dialogWindow.closed))) {
-			this.getPluginInstance("EditorMode").setHTML(this.getPluginInstance("EditorMode").getInnerHTML().replace(this.cleanUpRegularExpression,"$2"));
+			this.editor.setHTML(this.editor.getInnerHTML().replace(this.cleanUpRegularExpression,"$2"));
 			this.dialog.close();
 		} else {
-			this.editor._iframe.contentWindow.setTimeout(this.cleanUpFunctionReference, 200);
+			this.cleanUp.defer(200, this);
 		}
 	}
 });
